<?php
if ( function_exists( 'add_theme_support' ) ) { // Added in 2.9
add_theme_support( 'post-thumbnails', array( 'post', 'page' ) );
	set_post_thumbnail_size( 150, 150, true ); // thumbnail
}

if ( ! isset( $content_width ) ) $content_width = 590;

// Get Theme Options Page
if(is_admin()) :
require_once ('theme-options.php');
endif;

add_theme_support('automatic-feed-links');
remove_action('wp_head', 'wp_generator');

// Sidebar Widget
if ( function_exists('register_sidebar') ) 
register_sidebar(array(
'name' => 'Sidebar',
'before_widget' => '<div class="list">',
'after_widget' => '</div><br /><br />',
'before_title' => '<h2 class="sub">',
'after_title' => '</h2>',
));

// post_thumbnail
function post_thumbnail( $width = 100,$height = 80 ){ //略缩图默认大小
global $post;
if( has_post_thumbnail() ){
$timthumb_src =wp_get_attachment_image_src(get_post_thumbnail_id($post->ID),'full');
$post_timthumb = '<img src="'.get_bloginfo("template_url").'/timthumb.php?src='.$timthumb_src[0].'&amp;h='.$height.'&amp;w='.$width.'&amp;zc=1" alt="'.$post->post_title.'" />';
echo $post_timthumb;
} else {
$post_timthumb = '';
ob_start();
ob_end_clean();
$output = preg_match('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i',$post->post_content, $index_matches);
$first_img_src = $index_matches [1];
if( !empty($first_img_src) ){
$path_parts = pathinfo($first_img_src);
$first_img_name = $path_parts["basename"];
$first_img_pic = get_bloginfo('wpurl').'/cache/'.$first_img_name;
$first_img_file = ABSPATH. 'cache/'.$first_img_name; //保存地址
$expired = 604800; //略缩图过期时间
if ( !is_file($first_img_file) || (time() -filemtime($first_img_file)) > $expired ){
copy($first_img_src, $first_img_file);
$post_timthumb = '<img src="'.$first_img_src.'" alt="'.$post->post_title.'" />';
}
$post_timthumb = '<img src="'.get_bloginfo("template_url").'/timthumb.php?src='.$first_img_pic.'&amp;h='.$height.'&amp;w='.$width.'&amp;zc=1" alt="'.$post->post_title.'" />';
} else {
$post_timthumb = '<img src="'.get_bloginfo("template_url").'/images/default_thumb.gif" alt="'.$post->post_title.'" />'; //如果日志中没有图片，则显示默认，自行制作默认图片
}
echo $post_timthumb;
}
}

/*
pagenavi
*/
function pagenavi( $p = 2 ) {
if ( is_singular() ) return;
global $wp_query, $paged;
$max_page = $wp_query->max_num_pages;
if ( $max_page == 1 ) return;
if ( empty( $paged ) ) $paged = 1;
echo '<span class="page-numbers">第 ' . $paged . ' 页 , 共 ' . $max_page . ' 页</span> ';
if ( $paged > $p + 1 ) p_link( 1, '最前页' );
if ( $paged > $p + 2 ) echo '<span class="page-numbers">...</span>';
for( $i = $paged - $p; $i <= $paged + $p; $i++ ) {
if ( $i > 0 && $i <= $max_page ) $i == $paged ? print "<span class='current'>{$i}</span> " : p_link( $i );
}
if ( $paged < $max_page - $p - 1 ) echo '<span class="page-numbers">...</span>';
if ( $paged < $max_page - $p ) p_link( $max_page, '最末页' );
}
function p_link( $i, $title = '' ) {
if ( $title == '' ) $title = "第 {$i} 页";
echo "<a href='", esc_html( get_pagenum_link( $i ) ), "' title='{$title}'>{$i}</a> ";
}

/*
Displays the top 10 commentators
<?php dp_top_commentators(10); ?>
*/
function dp_top_commentators($limit=10) {
	global $wpdb;
	$sql = "SELECT $wpdb->comments.comment_author, $wpdb->comments.comment_author_email, $wpdb->comments.comment_author_url, COUNT( $wpdb->comments.comment_ID ) AS comment_count FROM $wpdb->comments WHERE MONTH(comment_date)=MONTH(now()) and YEAR(comment_date)=YEAR(now()) AND comment_author != 'Jeff' AND $wpdb->comments.comment_approved=1 Group BY $wpdb->comments.comment_author_email ORDER BY comment_count LIMIT $limit";
	$topcommentators = $wpdb->get_results($sql, OBJECT);
	foreach ($topcommentators as $tc) {
		?>
		<span><a class="username" href="<?php echo $tc->comment_author_url; ?>"><?php echo $tc->comment_author; ?></a></span> / 
		<?php
	}
}

/*
New Icon Images <?php childtheme_post_header() ?>
*/
function childtheme_post_header(){
	if ( (time()-get_the_time('U')) <= (2*86400) ) {
		echo '<div class="new">NEW!</div>';
	}
}

/*
Displays post image attachment (sizes: thumbnail, medium, full)
*/
function dp_attachment_image($postid=0, $size='thumbnail', $attributes='') {
	if ($postid<1) $postid = get_the_ID();
	if ($images = get_children(array(
		'post_parent' => $postid,
		'post_type' => 'attachment',
		'numberposts' => 1,
		'post_mime_type' => 'image',)))
		foreach($images as $image) {
			$attachment=wp_get_attachment_image_src($image->ID, $size);
			?><img src="<?php echo $attachment[0]; ?>" <?php echo $attributes; ?> class="glide-image-small"/><?php
		}
}
?>